/*
 * MAP66: Network Address Translation IPv6-to-IPv6 as
 * proposed in the IETF's second NAT66 draft document.
 * (c) 2010 sven-ola()gmx.de
 */

#ifndef _IP6T_MAP66_H
#define _IP6T_MAP66_H

#define IP6T_MAP66_STR_DST_TO   "dst-to"
#define IP6T_MAP66_STR_SRC_TO   "src-to"
#define IP6T_MAP66_STR_NOCHECK  "nocheck"
#define IP6T_MAP66_STR_CSUM     "csum"
#define IP6T_MAP66_STR_DST_SWAP "dst-swap"
#define IP6T_MAP66_STR_SRC_SWAP "src-swap"

#define IP6T_MAP66_OPT_DST_TO   0x01
#define IP6T_MAP66_OPT_SRC_TO   0x02
#define IP6T_MAP66_OPT_NOCHECK  0x04
#define IP6T_MAP66_OPT_CSUM     0x08
#define IP6T_MAP66_OPT_DST_SWAP 0x10
#define IP6T_MAP66_OPT_SRC_SWAP 0x20

struct ip6t_MAP66_info {
	struct in6_addr	pfix_dst_to;	/* The prefix to map destination addrs to */
	u_int16_t	pfix_dst_len;	/* Destination addrs prefix length DIV 16 */
	u_int16_t	pfix_dst_csum;	/* Pre-calculated csum for destination addrs */
	struct in6_addr	pfix_src_to;	/* The prefix to map source addrs from */
	u_int16_t	pfix_src_len;	/* Source addrs prefix length DIV 16 */
	u_int16_t	pfix_src_csum;	/* Pre-calculated csum for source addrs */
	u_int16_t	mapflags;	/* Some flags */
};

extern void _init(void);

#endif /*_IPT_MAP66_H*/
